#include "importevents.h"
#include "ui_importevents.h"
#include <QFileDialog>
#include <QFile>
#include <QDebug>
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlError>
#include <QSqlRecord>

//QSqlRecord rec;
//QSqlDatabase db;
//QSqlDatabase db;

int iEventID = -1;

importevents::importevents(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::importevents)
{
    ui->setupUi(this);
}

importevents::~importevents()
{
    delete ui;
}

void importevents::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void importevents::on_pushBrowse_clicked()
{

    QString fileName;

    QString homepath(QDir::home().path());

    fileName = QFileDialog::getOpenFileName(this,
         tr("Open Event Info"), homepath, tr("Event Files (*.txt)"));

    ui->plainFileName->setPlainText(fileName);
}

void importevents::on_pbSoccerDB_clicked()
{
//    QSqlDatabase db;

    #ifdef Q_OS_LINUX
//                QString xmlpath(QDir::home().path());
//                xmlpath.append(QDir::separator()).append("hsk.xml");
//                xmlpath = QDir::toNativeSeparators(xmlpath);
//        qDebug() << "XML path:" << xmlpath;
//                QFile file(xmlpath);
    #else
//                QFile file( "./hsk.xml" );
    #endif
//    QFile file(ui->plainFileName);

    ui->lblImporting->setText("Importing...");

//    createDatabase();
//    purgeDatabase();
    qApp->processEvents();

    createDatabase();

    importSoccerDBLeagues();

    ui->lblImporting->setText("");

    return;

}


void importevents::on_pushImport_clicked()
{
//    QSqlDatabase db;

    #ifdef Q_OS_LINUX
//                QString xmlpath(QDir::home().path());
//                xmlpath.append(QDir::separator()).append("hsk.xml");
//                xmlpath = QDir::toNativeSeparators(xmlpath);
//        qDebug() << "XML path:" << xmlpath;
//                QFile file(xmlpath);
    #else
//                QFile file( "./hsk.xml" );
    #endif
//    QFile file(ui->plainFileName);

    ui->lblImporting->setText("Importing...");

//    createDatabase();
//    purgeDatabase();
    qApp->processEvents();

    createDatabase();
    QSqlQuery qry;

    qry.prepare("BEGIN");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    createEvent(ui->txtEventName->toPlainText(),QString(""),QString(""),QString(""),0);
    importGames(ui->plainFileName->toPlainText());
    qry.prepare("COMMIT");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    ui->lblImporting->setText("");

    return;

}

void importevents::importdelimited(QString filename)
{
    QFile filedelimited(filename);
    QString strDelimiter;
    QSqlQuery qry;


    filedelimited.open( QIODevice::ReadOnly );

    QTextStream filestream(&filedelimited);
    filestream.setCodec("UTF-8");

    qry.prepare("BEGIN");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    QString line;
    while (!filestream.atEnd()) {
    }


    filedelimited.close();

    qry.prepare("COMMIT");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    filedelimited.setPermissions(QFile::ReadOwner | QFile::WriteOwner | QFile::ReadUser |QFile::WriteUser);

}


void importevents::importSoccerDBLeagues()
{
    QFile filedelimited(ui->plainFileName->toPlainText());
    int i;
    bool bisFirstLine =true;
    QString strDelimiter;
    QSqlQuery qry;


    filedelimited.open( QIODevice::ReadOnly );

    QTextStream filestream(&filedelimited);
    filestream.setCodec("UTF-8");

    qry.prepare("BEGIN");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    QString line;
    while (!filestream.atEnd()) {
        line = filestream.readLine();
        line.truncate(line.length());

        if (bisFirstLine)
        {
            qDebug() << line;
            //Identify the used delimiter
            if (line.indexOf("|")!= -1)
            {
                strDelimiter = "|";
            }
            else if (line.indexOf("\t")!= -1)
            {
                strDelimiter = "\t";
            }
            else if (line.indexOf(",")!= -1)
            {
                strDelimiter = ",";
            }
            else if (line.indexOf(";")!= -1)
            {
                strDelimiter = ";";
            }
            else if (strDelimiter=="")
            {
                qDebug() << "Unknown Delimiter";
                return;
            }
            bisFirstLine = false;

       }

        QStringList list1 = line.split(strDelimiter);

        for (i=0; i<list1.count(); i++)
        {
            qDebug() << list1[i];
        }
        createEvent(list1[1], QString("Football"), list1[2], list1[0], list1[3].toInt());
//        void importevents::createEvent(QString sEventName,
//                                       QString sSport,
//                                       QString sSeason,
//                                       QString sRegion,
//                                       int iSoccerDbID)

    }

    qry.prepare("COMMIT");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

}

void importevents::purgeDatabase()
{
    QSqlQuery qry;

    if (!qry.exec("DELETE FROM events"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("DELETE FROM teams"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("DELETE FROM teamgroups"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("DELETE FROM games"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

}

void importevents::importGames(QString sFileName)
{
    QFile filedelimited(sFileName);
    int i;
    int iGroupID;
    bool bisFirstLine =true;
    QString strDelimiter;
    QSqlQuery qry;


    filedelimited.open( QIODevice::ReadOnly );

    QTextStream filestream(&filedelimited);
    filestream.setCodec("UTF-8");

    qry.prepare("BEGIN");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    QString line;
    while (!filestream.atEnd()) {
        line = filestream.readLine();
        line.truncate(line.length());

        if (bisFirstLine)
        {
            qDebug() << line;
            //Identify the used delimiter
            if (line.indexOf("|")!= -1)
            {
                strDelimiter = "|";
            }
            else if (line.indexOf("\t")!= -1)
            {
                strDelimiter = "\t";
            }
            else if (line.indexOf(",")!= -1)
            {
                strDelimiter = ",";
            }
            else if (line.indexOf(";")!= -1)
            {
                strDelimiter = ";";
            }
            else if (strDelimiter=="")
            {
                qDebug() << "Unknown Delimiter";
                return;
            }
            bisFirstLine = false;

       }


        QStringList list1 = line.split(strDelimiter);

        for (i=0; i<list1.count(); i++)
        {
            qDebug() << list1[i];
        }
        iGroupID = createGroup(list1[0]);
        createTeam(list1[3], iGroupID );
        createTeam(list1[4], iGroupID );
        createGame(list1);
    }

    qry.prepare("COMMIT");
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

}


//"(name TEXT, sport TEXT, season TEXT, region TEXT)"))

void importevents::createEvent(QString sEventName,
                               QString sSport,
                               QString sSeason,
                               QString sRegion,
                               int iSoccerDbID)
{
    QSqlQuery qry;

    qDebug() << "sEventName" << sEventName;

    qry.prepare("SELECT rowid FROM events WHERE sport=:sport and region=:region and name=:name and season=:season");
    qry.bindValue(":sport", sSport);
    qry.bindValue(":region", sRegion);
    qry.bindValue(":name", sEventName);
    qry.bindValue(":season", sSeason);

    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    iEventID = -1;

    while (qry.next()) {
        iEventID = qry.value(0).toInt();
        qDebug() << iEventID;
     }

    // Only insert if the Group does not already exist.
    if (iEventID < 1)
    {
        qry.prepare("INSERT INTO events (name, sport, season, region, soccerdbid) VALUES "
                    "(:name, :sport, :season, :region, :soccerdbid)");

        qry.bindValue(":name", sEventName);
        qry.bindValue(":sport", sSport);
        qry.bindValue(":season", sSeason);
        qry.bindValue(":region", sRegion);
        qry.bindValue(":soccerdbid", iSoccerDbID);


        if (!qry.exec())
        {
            qDebug() << qry.lastQuery();
            qDebug() << qry.lastError();
            qDebug() << qry.executedQuery();
            qDebug() << qry.boundValues();
        }
        else
        {
            qDebug() << "Event:" << sEventName;
            iEventID = qry.lastInsertId().toInt();
            qDebug() << "EventID:" << iEventID;
        }
    }
}

int importevents::createGroup(QString sGroupName)
{
    QSqlQuery qry;
    int iGroupRowID = -1;

    qDebug() << "sGroupName" << sGroupName;

    qry.prepare("SELECT rowid FROM teamgroups WHERE name=:name and eventrowid=:eventrowid");
    qry.bindValue(":name", sGroupName);
    qry.bindValue(":eventrowid", iEventID);

    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (qry.next()) {
        iGroupRowID = qry.value(0).toInt();
        qDebug() << iGroupRowID;
     }

    // Only insert if the Group does not already exist.
    if (iGroupRowID < 0)
    {
        qry.prepare("INSERT INTO teamgroups (name, eventrowid) VALUES "
                    "(:name, :eventrowid)");

        qry.bindValue(":name", sGroupName);
        qry.bindValue(":eventrowid", iEventID);

        if (!qry.exec())
        {
            qDebug() << qry.lastQuery();
            qDebug() << qry.lastError();
            qDebug() << qry.executedQuery();
            qDebug() << qry.boundValues();
        }
        else
        {
            qDebug() << "Group:" << sGroupName;
            qDebug() << "EventID:" << iEventID;
            iGroupRowID = qry.lastInsertId().toInt();
        }
    }
    qDebug() << "RowID:" << iGroupRowID;
    return iGroupRowID;
}



void importevents::createTeam(QString sTeamName, int iGroupRowID)
{
    QSqlQuery qry;
    int iTeamCount;

    qDebug() << "sTeamName" << sTeamName;

    qry.prepare("SELECT COUNT(*) as teamcount FROM teams WHERE name=:name and grouprowid=:grouprowid");
    qry.bindValue(":name", sTeamName);
    qry.bindValue(":grouprowid", iGroupRowID);

    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    qDebug() << "rowid" << qry.value(0).toInt();
    qDebug() << "name" << qry.value(1).toString();
    qDebug() << "teams qry.size()" << qry.size() ;

    while (qry.next()) {
        iTeamCount= qry.value(0).toInt();
        qDebug() << iTeamCount;
     }

    // Only insert if the Team does not already exist.
    if (iTeamCount< 1)
    {
        qry.prepare("INSERT INTO teams (name, grouprowid) VALUES "
                    "(:name, :grouprowid)");

        qry.bindValue(":name", sTeamName);
        qry.bindValue(":grouprowid", iGroupRowID);

        if (!qry.exec())
        {
            qDebug() << qry.lastQuery();
            qDebug() << qry.lastError();
            qDebug() << qry.executedQuery();
            qDebug() << qry.boundValues();
        }
        else
        {
            qDebug() << "Team:" << sTeamName << iGroupRowID;
        }
    }

}

void importevents::createGame(QStringList sGameList)
{

    int ihometeamrowid;
    int iawayteamrowid;
    int igrouprowid;
    QSqlQuery qry;

    qry.prepare("SELECT rowid FROM teams WHERE name=:name");
    qry.bindValue(":name", sGameList[3]);

    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }
    qry.next();
    ihometeamrowid = qry.value(0).toInt();

    qry.prepare("SELECT rowid FROM teams WHERE name=:name");
    qry.bindValue(":name", sGameList[4]);
    qDebug() << "awayteam:" << sGameList[4];
    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }
    qry.next();
    iawayteamrowid = qry.value(0).toInt();
    qDebug() << "iawayteamrowid" << iawayteamrowid ;

    qry.prepare("SELECT rowid FROM teamgroups WHERE name=:name");
    qry.bindValue(":name", sGameList[0]);

    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }
    qry.next();
    igrouprowid = qry.value(0).toInt();

    qry.prepare("INSERT INTO games (grouprowid, hometeamrowid, awayteamrowid, gametime, homegoals, awaygoals, round) VALUES "
                "(:grouprowid, :hometeamrowid, :awayteamrowid, :gametime, :homegoals, :awaygoals, :round)");

    qry.bindValue(":grouprowid", igrouprowid);
    qDebug() << "grouprowid" << igrouprowid;
    qry.bindValue(":round", sGameList[1]);
    qDebug() << "round" << sGameList[1];
    qry.bindValue(":gametime", sGameList[2]);
    qDebug() << "gametime" << sGameList[2];
    qry.bindValue(":hometeamrowid", ihometeamrowid);
    qDebug() << "hometeamrwoid" << ihometeamrowid;
    qry.bindValue(":awayteamrowid", iawayteamrowid);
    qDebug() << "awayteamrowid" << iawayteamrowid;
    if (sGameList.size()>5)
    {
        qry.bindValue(":homegoals", sGameList[5]);
        qry.bindValue(":awaygoals", sGameList[6]);
    }
    else
    {
        qry.bindValue(":homegoals", 0);
        qry.bindValue(":awaygoals", 0);
    }

    if (!qry.exec())
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
        qDebug() << qry.executedQuery();
        qDebug() << qry.boundValues();
    }

}

void importevents::createDatabase()
{

    QSqlDatabase db;
    db = QSqlDatabase::addDatabase("QSQLITE");

    #ifdef Q_OS_LINUX
                // NOTE: We have to store database file into user home folder in Linux
                QString path(QDir::home().path());
                path.append(QDir::separator()).append("qsportsevent.db");
                path = QDir::toNativeSeparators(path);
        qDebug() << "Db path:" << path;
                db.setDatabaseName(path);
    #else
                // NOTE: File exists in the application private folder, in Symbian Qt implementation
                db.setDatabaseName("qsportsevent.db");
    #endif

    if (!db.open())
    {
        qDebug() << "Failed to connect";
        qDebug() << db.lastError();
    }

    QSqlQuery qry;

    if (!qry.exec("CREATE TABLE IF NOT EXISTS teams "
        "(name TEXT, flag TEXT, grouprowid INT)"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("CREATE TABLE IF NOT EXISTS games "
        "(hometeamrowid INT, awayteamrowid INT, grouprowid INT, gametime TEXT, homegoals INT, awaygoals INT, round INT)"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("CREATE TABLE IF NOT EXISTS teamgroups "
                  "(name TEXT, eventrowid INT )"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("CREATE TABLE IF NOT EXISTS events "
                  "(name TEXT, sport TEXT, season TEXT, region TEXT, soccerdbid INT)"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

    if (!qry.exec("CREATE TABLE IF NOT EXISTS favourites "
                  "(showdefault INT, sport TEXT, region TEXT, name TEXT, url TEXT)"))
    {
        qDebug() << qry.lastQuery();
        qDebug() << qry.lastError();
    }

}

